#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[] = "0.8 (edit by SirD.)";

#define ACCESS_RESTRICT 8192

#define MENU_NONE		0
#define MENU_RIFLES     4
#define MENU_PRIMAMMO	6
#define MENU_SECAMMO	7
#define MENU_EQUIPMENT	8
#define MENU_INVALID    9
#define MENU_CANCEL		10
#define MENU_MAIN		11

new g_sb_awplimit = -1;
new g_AwpCount[MAX_PLAYERS];
new g_UserMenuSelected[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("AWP limit script","Lets you limit how many times one person can buy the AWP.",STRING_VERSION);
	plugin_registercmd("admin_awplimit","admin_awplimit",ACCESS_RESTRICT,"admin_awplimit <limit>: Changes the limit for amount of AWP purchases, -1 for no limit.");
	//User command events:
	plugin_registercmd("buy","buy",ACCESS_ALL);
	plugin_registercmd("buyequip","buyequip",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("radio1","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio2","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio3","ClearMenu",ACCESS_ALL);
	plugin_registercmd("chooseteam","ClearMenu",ACCESS_ALL);
	//plugin_registercmd("say","HandleSay",ACCESS_ALL);
	//plugin_registercmd("checkawp","CheckAWP",ACCESS_ALL);
	plugin_registercmd("awp","awp",ACCESS_ALL);

	//Get vault value to save across map changes and stuff
	get_vaultnumdata("admin_awplimit",g_sb_awplimit);
	
	return PLUGIN_CONTINUE;
}

public admin_awplimit(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	//Data[0] means Data isn't empty (usually)
	if (strlen(Data)!=0) {
		g_sb_awplimit = strtonum(Data);
		set_vaultnumdata("admin_awplimit",g_sb_awplimit);
	}
	//Tell the admin what the limit is (does it even if it was empty so it just reports)
	snprintf(Text, MAX_TEXT_LENGTH, "AWP limit is ^"%i^"", g_sb_awplimit);
	messageex(User, Text, print_console);
	return PLUGIN_HANDLED;
}

public buy(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_MAIN;
    return PLUGIN_CONTINUE;
}

public buyequip(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_EQUIPMENT;
    return PLUGIN_CONTINUE;
}

public ClearMenu(HLCommand,HLData,HLUserName,UserIndex) {
    g_UserMenuSelected[UserIndex] = MENU_NONE;
    return PLUGIN_CONTINUE;
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(g_UserMenuSelected[UserIndex] != MENU_NONE){
		new Data[MAX_DATA_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iSelectedNumber;
		new iTeam;
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		iSelectedNumber=strtonum(Data);
		
		say(Data);

		if(iSelectedNumber == MENU_CANCEL) {
			g_UserMenuSelected[UserIndex] = MENU_NONE;
		}	
		if(g_UserMenuSelected[UserIndex]==MENU_MAIN){
			if(iSelectedNumber == MENU_PRIMAMMO || iSelectedNumber == MENU_SECAMMO || iSelectedNumber == MENU_INVALID) {
				if(getvar("allow_client_exec")) {
					execclient(User,"menuselect 10");
				}
			} else {
				g_UserMenuSelected[UserIndex] = iSelectedNumber;
			}
		}else if(g_UserMenuSelected[UserIndex] == MENU_RIFLES){
			get_userTeam(User,iTeam);
			if(iTeam==1){
				if(iSelectedNumber==5){
					if(g_AwpCount[UserIndex]<g_sb_awplimit){
						g_AwpCount[UserIndex]+=1;
						display_awp(User,UserIndex);
					}else if(g_AwpCount[UserIndex]>=g_sb_awplimit){
						display_awp(User,UserIndex);
						return PLUGIN_HANDLED;
					}
				}
			}else if(iTeam==2){
				if(iSelectedNumber==6 ){
					if(g_AwpCount[UserIndex]<g_sb_awplimit){
						g_AwpCount[UserIndex]+=1;
						display_awp(User,UserIndex);
					}else if(g_AwpCount[UserIndex]>=g_sb_awplimit){
						display_awp(User,UserIndex);
						return PLUGIN_HANDLED;
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

display_awp(User[],UserIndex){
	new Text[MAX_TEXT_LENGTH];
	snprintf(Text,MAX_TEXT_LENGTH,"You have purchased (%i/%i) allowed AWPs.",g_AwpCount[UserIndex],g_sb_awplimit);
	messageex(User,Text,print_chat);
	if(g_AwpCount[UserIndex]>=g_sb_awplimit){
		snprintf(Text,MAX_TEXT_LENGTH,"You are not allowed to buy more AWPs.");
		messageex(User,Text,print_chat);
	}	
}


public awp(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_AwpCount[UserIndex]<g_sb_awplimit){
		g_AwpCount[UserIndex]+=1;
		display_awp(User,UserIndex);
	}else{
		display_awp(User,UserIndex);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}
